# norootforbuild
%define		srctag 3.1.2
Summary:	Write back block cache for SSD devices
Name:		flashcache
Version:	3.1.2
License:	GPL
Release:	77.1
Group:		System/Kernel
Source0:	%{name}-%{srctag}.tar.bz2
Source1:	boot.flashcache
Source2:	mdwn2man
Patch0:		flashcache-3.1.2_dmtarget.patch
BuildRoot:	%{_tmppath}/%{name}-%{srctag}-root
BuildRequires:	kernel-source kernel-syms module-init-tools


%suse_kernel_module_package ec2 xenpae vmi um

%define _initdir /etc/init.d

%description
Kernel modules for write-back block cache driver

%package utils
Group: System/Base
License: GPL v2 or later
Summary: Utilities
Requires: device-mapper mdadm udev

%description utils
Utilities for setting up a write-back block cache

%package -n flashcache-KMP
Group: System/Kernel
License: GPL v2 or later
Summary: Kernel modules
Requires: kernel-default kernel-desktop

%description -n flashcache-KMP
Kernel modules for write-back block cache driver

%prep
%setup -n %{name}-%{srctag}
%if 0%{?sles_version_sp} == 3
%patch0
%endif

set -- *   
mkdir source   
mv "$@" source/   
mkdir obj
  
%build  
export KBUILD_VERBOSE=1
export CFLAGS="$RPM_OPT_FLAGS"
for flavor in %flavors_to_build; do   
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    pushd obj/$flavor/src
    export KERNEL_TREE=/usr/src/linux-obj/%_target_cpu/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules M=$PWD
    popd
done
pushd source/src/utils
make %{?_smp_mflags}
popd
cp %{S:2} source/man/
chmod +x source/man/mdwn2man

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do   
    pushd obj/$flavor/src
    export KERNEL_TREE=/usr/src/linux-obj/%_target_cpu/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install M=$PWD
    popd
done
pushd source/src/utils
make install DESTDIR=$RPM_BUILD_ROOT INSTALL="%{__install} -p"
popd
# build man pages
pushd source/man
%__install -d -m0755 %{buildroot}%{_mandir}/man8
for a in `ls -1A *.mdwn` ; do
b=`basename $a .mdwn`
cat ${a} | ./mdwn2man > %{buildroot}%{_mandir}/man8/$b.8
done
popd
install -D -m0755 %{S:1} %{buildroot}%{_initdir}/boot.flashcache

%post
/sbin/depmod -a

%postun
/sbin/depmod -a

%postun utils
if [ $1 == 0 ] ; then
%insserv_cleanup
fi

%post utils
if [ $1 == 1 ] ; then
/sbin/chkconfig boot.flashcache B || :
fi

%preun utils
if [ $1 == 0 ] ; then
/sbin/chkconfig boot.flashcache off || :
/sbin/service boot.flashcache stop || :
fi

%files utils
%defattr(-,root,root,-)
/sbin/flashcache_create
/sbin/flashcache_destroy
/sbin/flashcache_load
/sbin/flashcache_setioctl
/sbin/get_agsize
%{_initdir}/boot.flashcache
%{_mandir}/man8/flashcache.8*
%{_mandir}/man8/flashcache_create.8*
%{_mandir}/man8/flashcache_destroy.8*

%changelog
* Fri Oct 24 2014 cs@linux-administrator.com
- update to release 3.1.2
* Sun Sep  1 2013 cs@linux-administrator.com
- update to release 2.1
* Sun Jan  8 2012 cs@linux-administrator.com
- added boot.flashcache
* Sun Jan  8 2012 cs@linux-administrator.com
- initial build
